#!/usr/bin/env perl
use strict;

#
# The binary_c stellar population nucleosynthesis framework.
#
# Copyright Robert Izzard 2000-2021
#
# Contact rob.izzard@gmail.com
#
# Code repository:
# https://gitlab.com/binary_c
#
# Documentation is in doc/
# Code is in src/
#
# To build, run
#
# ---
#
# meson builddir
# cd builddir
# ninja binary_c_install
#
# ---
#
# Please see the files README, LICENCE and CHANGES,
# and the doc/ directory for documentation which is mirrored
# at https://binary_c.gitlab.io/binary_c.html
#
######################
#
# Purpose:
#
# script to make binary_c_version_macros.h
#
######################


my $colour =
{
    'magenta' => '[35m',
    'black' => '[30m',
    'bold yellow' => '[1;33m',
    'bold white' => '[1;37m',
    'green' => '[32m',
    'bold green' => '[1;32m',
    'cyan' => '[36m',
    'bold black' => '[1;30m',
    'bold blue' => '[1;34m',
    'bold magenta' => '[1;35m',
    'blue' => '[34m',
    'bold cyan' => '[1;36m',
    'bold red' => '[1;31m',
    'red' => '[31m',
    'yellow' => '[33m',
    'reset' => '[0m',
    'white' => '[37m'
};

my $version = slurp('src/binary_c_version.h');
$version = ($version =~
            /\#define\s+BINARY_C_VERSION\s+\"([^\"]+)\"\s+/)[0];
my ($major,$minor,$patch,$pre) = ($version=~/^(\d+)\.(\d+)(?:\.(\d+))?(?:pre)?(\d*)/);
print $colour->{'green'},"Version $version -> Major $major, Minor $minor, Patch $patch";
if(defined $pre)
{
    print " Pre $pre";
}
print $colour->{'reset'},"\n";
open(HEADER,'>','src/binary_c_version_macros.h');
print HEADER "
    /*
    * This file is automatically generated by the binary_c
    * configure script.
    *
    * Please do not change it by hand or add it to the git
    * repository!
    */
    \#pragma once
    \#ifndef BINARY_C_VERSION_MACROS_H
    \#define BINARY_C_VERSION_MACROS_H

    \#define BINARY_C_MAJOR_VERSION $major
    \#define BINARY_C_MINOR_VERSION $minor
    \#define BINARY_C_PATCH_VERSION $patch
    \#define BINARY_C_PRE_VERSION $pre

    \#endif // BINARY_C_VERSION_MACROS_H
    ";
close HEADER;

sub slurp
{
    # taken from rob_misc.pm
    open(my $fh,'<'.$_[0])||die("cannot open $_[0] in slurp");
    return (do { local( $/ ) ; <$fh> } );
}
